]> git.sesse.net Git - mlt/blobdiff - src/modules/avformat/configure
set version to 0.8.0
[mlt] / src / modules / avformat / configure
index cbecb5dc24e034dc0cc1da5c3babcc39a8f5a504..c64cec83092b11f6e72b94567d95b6fc58f60b7b 100755 (executable)
-#!/bin/bash
+#!/bin/sh
 
-if [ "$help" != "1" ]
+# Determine whether to recommend/use the HEAD revision of FFmpeg (unreleased)
+# or a specific revision based upon whether the last digit of our version
+# is even or odd. An odd MLT version number always represents unreleased.
+ffmpeg_ver="0.9.2"
+libav_ver="0.8.2"
+micro_version=$(echo $version | cut -d . -f 3)
+odd_version=$(($micro_version % 2))
+[ "$odd_version" -eq "1" ] && ffmpeg_ver="HEAD" && libav_ver="HEAD"
+
+if [ "$help" = "1" ]
 then
+       cat << EOF
+FFmpeg/avformat options:
 
-cat << EOF >> ../producers.dat
-avformat               libmltavformat.so
-EOF
+  --avformat-shared=path  - Link against a shared installation of libavformat (default)
+  --avformat-static=path  - Link against a static build of libavformat
+  --avformat-ldextra=libs - Provide additional libs to link with
+  --avformat-swscale      - Use libswcale instead of img_convert (with --avformat-static)
+  --avformat-suffix=suff  - Specify a custom suffix
+  --avformat-no-codecs    - Disable the producer and consumer to avoid the codecs
+  --avformat-no-filters   - Disable the filters to make a codecs+muxers-only plugin
+  --avformat-no-devices   - Disable support for libavdevice
+  --avformat-vdpau        - Enable support for NVIDIA VDPAU
 
-cat << EOF >> ../filters.dat
-avdeinterlace  libmltavformat.so
-avresample             libmltavformat.so
-EOF
+  NOTE: The recommended version of FFmpeg is $ffmpeg_ver or libav $libav_ver.
 
-cat << EOF >> ../consumers.dat
-avformat               libmltavformat.so
 EOF
 
-fi
+else
+       targetos=$(uname -s)
+       case $targetos in
+       Darwin)
+               export LIBSUF=.dylib
+               ;;
+       Linux|FreeBSD|NetBSD)
+               export LIBSUF=.so
+               ;;
+       *)
+               ;;
+       esac
+               
+       bits=$(uname -m)
+       case $bits in
+       x86_64)
+               [ -d /usr/lib/lib64 ] && export LIBDIR=lib64 || export LIBDIR=lib
+               ;;
+       *)
+               export LIBDIR=lib
+               ;;
+       esac
+
+       echo > config.mak
 
+       export static_ffmpeg=
+       export shared_ffmpeg=$(pkg-config --variable=prefix libavformat)
+       export extra_libs=
+       export avformat_suffix=
+       export swscale=
+       export codecs=true
+       export filters=true
+       export devices=true
+       export vdpau=false
+       pkg-config x11 > /dev/null 2>&1
+       export x11=$?
+
+       for i in "$@"
+       do
+               case $i in
+                       --avformat-static=* )   static_ffmpeg="${i#--avformat-static=}" ;;
+                       --avformat-shared=* )   shared_ffmpeg="${i#--avformat-shared=}" ;;
+                       --avformat-ldextra=* )  extra_libs="${i#--avformat-ldextra=}" ;;
+                       --avformat-suffix=* )   avformat_suffix="${i#--avformat-suffix=}" ;;
+                       --avformat-swscale )    swscale=true ;;
+                       --avformat-swscaler )   swscale=true ;;
+                       --avformat-no-codecs )  codecs=false ;;
+                       --avformat-no-filters ) filters=false ;;
+                       --avformat-no-devices ) devices=false ;;
+                       --avformat-no-vdpau )   vdpau=false ;;
+                       --avformat-vdpau )      vdpau=true ;;
+               esac
+       done
+
+       if [ "$static_ffmpeg" != "" ]
+       then 
+               if [ -d "$static_ffmpeg" ]
+               then
+                       echo "CFLAGS+=-DAVDATADIR=\\\"${static_ffmpeg}/ffpresets/\\\"" >> config.mak
+                       echo "CFLAGS+=-I$static_ffmpeg" >> config.mak
+                       echo "LDFLAGS+=-L$static_ffmpeg/libavformat -L$static_ffmpeg/libavcodec -L$static_ffmpeg/libavutil" >> config.mak
+                       [ $targetos = "Darwin" ] &&
+                               echo "LDFLAGS+=-single_module" >> config.mak
+                       if [ "$swscale" != "" ]
+                       then
+                               echo "LDFLAGS+=-L$static_ffmpeg/libswscale" >> config.mak
+                               echo "SWSCALE=1" >> config.mak
+                       fi
+                       if [ "$devices" = "true" ]
+                       then
+                               echo "LDFLAGS+=-L$static_ffmpeg/libavdevice" >> config.mak
+                       fi
+                       echo "LDFLAGS+=-Wl,-Bsymbolic" >> config.mak
+                       extra_libs="$extra_libs -lm -lz -lbz2"
+                       
+                       if [ "$vdpau" = "true" ]
+                       then
+                               printf "#include <libavcodec/vdpau.h>\n int main(){ VdpBitstreamBuffer test; test.struct_version; return 0;}" | gcc -I"$static_ffmpeg" $CFLAGS -c -x c -  >/dev/null 2>&1
+                               [ "$x11" = "0" -a "$?" = "0" ] && echo "VDPAU=1" >> config.mak
+                       fi
+               else
+                       echo "avformat: Invalid path specified: $static_ffmpeg"
+                       touch ../disable-avformat
+                       echo 0
+               fi
+       elif [ "$shared_ffmpeg" != "" ]
+       then
+               echo "PREFIX=$shared_ffmpeg" >> config.mak
+               case $targetos in
+                       MINGW32_NT-*)
+                               echo "CFLAGS+=-DAVDATADIR=\\\"share/ffmpeg/\\\"" >> config.mak
+                       ;;
+                       *)
+                               echo "CFLAGS+=-DAVDATADIR=\\\"${shared_ffmpeg}/share/ffmpeg/\\\"" >> config.mak
+                       ;;
+               esac
+               echo "CFLAGS+=$(pkg-config --cflags libavformat)" >> config.mak
+               echo "LDFLAGS+=$(pkg-config --libs-only-L libavformat)" >> config.mak
+               if [ "$devices" = "true" ]
+               then
+                       echo "CFLAGS+=$(pkg-config --cflags libavdevice)" >> config.mak
+                       echo "LDFLAGS+=$(pkg-config --libs-only-L libavdevice)" >> config.mak
+               fi
+               avcodec_version=$(pkg-config --modversion libavcodec)
+               if [ "$swscale" != "" ] || [ $(echo $avcodec_version | cut -d. -f1) -gt 52 ] || ( [ $(echo $avcodec_version | cut -d. -f1) -ge 52 ] && [ $(echo $avcodec_version | cut -d. -f2) -ge 21 ] )
+               then
+                       echo "CFLAGS+=$(pkg-config --cflags libswscale)" >> config.mak
+                       echo "LDFLAGS+=$(pkg-config --libs-only-L libswscale)" >> config.mak
+                       echo "SWSCALE=1" >> config.mak
+               fi
+               
+               if [ "$vdpau" = "true" ]
+               then
+                       printf "#include <libavcodec/vdpau.h>\n int main(){ VdpBitstreamBuffer test; test.struct_version; return 0;}" | gcc -I"$(pkg-config --cflags libavformat)" -I"$shared_ffmpeg/include" $CFLAGS -c -x c -  >/dev/null 2>&1
+                       [ "$x11" = "0" -a "$?" = "0" ] && echo "VDPAU=1" >> config.mak
+               fi
+       else
+               echo "- libavformat not found: disabling"
+               touch ../disable-avformat
+               exit 0
+       fi
+
+       echo "EXTRA_LIBS=$extra_libs" >> config.mak
+       echo "AVFORMAT_SUFFIX=$avformat_suffix" >> config.mak
+       [ "$codecs" = "true" ] && echo "CODECS=1" >> config.mak
+       [ "$filters" = "true" ] && echo "FILTERS=1" >> config.mak
+       [ "$devices" = "true" ] && echo "DEVICES=1" >> config.mak
+       exit 0
+
+fi